      SUBROUTINE BCR(NCH,FLN,NGAS,NYEAR_B,GMR,AY,TI,NBN)
      PARAMETER(NYE=20,NFR=16,NGHG=12,NFH=14)
      CHARACTER AA*3,FRN*8,AY*8,AAA*8,AMFG*8,FLN*150
      DIMENSION NOYE(NYE),AMR(NYE),FRN(NFR),AY(NGAS),GHG(NGHG),GFH(NFH),
     *AMR_N(NFR),GHG_N(NGHG),GFH_O(NFH),AMR_FR(NFR),GMR(NGAS),AMFG(NFH),
     $FLN(NCH),NBN(NGAS)
      COMMON /CO2YEAR/CO2PPM
CSPS      OPEN(UNIT=NCH,FILE=FLN,status='unknown')
CSPS      NYEAR_TMP=NYEAR_B ; NYEAR_B=1979 ! ***************************** 1979 BC
      READ(FLN(1),102)NB,NF
      DO JS=2,3
         READ(FLN(JS),101)(NOYE(8*(JS-2)+J),J=1,8)
      ENDDO
      READ(FLN(4),101)(NOYE(J),J=17,NYE)
      READ(FLN(5),100)AA
      IF(NYEAR_B.LT.1960)THEN
         NYEAR=1960
         NYEM=1
         NYEP=NYEM
      ELSE
         IF(NYEAR_B.GE.2060)THEN
            NYEAR=2060
            NYEM=20
            NYEP=NYEM
         ELSE
            NYEAR=NYEAR_B
            NYEM=(NYEAR-1955)/5
            NYEP=NYEM+1
            IF(NYEP.GT.20)NYEP=20
         ENDIF
      ENDIF
      AMCP=(TI+365.*(NYEAR-NOYE(NYEM)))/(5.*365.)
      AMCM=1.-AMCP
      JS=5
   1  JS=JS+1
      READ(FLN(JS),103)AA,AAA,NUMBER
      IF(AA.EQ.'END')GOTO2
      DO JJ=1,2
         JS=JS+1
         READ(FLN(JS),104)(AMR(J+(JJ-1)*8),J=1,8)
      ENDDO
      JS=JS+1
      READ(FLN(JS),104)(AMR(J),J=17,NYE)
 100  FORMAT(A3)
 101  FORMAT(8I10)
 102  FORMAT(45X,I3,16X,I3)
 103  FORMAT(A3,5X,A8,I8)
 104  FORMAT(8G10.3)
      DO 3 J=1,NGAS
         IF(AY(J).EQ.AAA)GOTO4
   3     CONTINUE
      GOTO1
   4  IF(NBN(J).EQ.2)GMR(J)=(AMR(NYEM)*AMCM+AMR(NYEP)*AMCP)*1.E-9
      GOTO1
C
C     WMO 2011 Boundary Conditions
C
   2  NYEAR=NYEAR_B
      IF(NYEAR.LT.1950.OR.NYEAR.GE.2099)GOTO9
      JS=JS+1
      READ(FLN(JS),105)FRN
      ANDAYS=365.
      IF(NYEAR/4*4.EQ.NYEAR)ANDAYS=366.
      AMC_P=TI/ANDAYS
      AMC_M=1.-AMC_P
 105  FORMAT(10X,16(2X,A8))
C      READ(NCH,100)AA
      JS=JS+1
   5  READ(FLN(JS),106)NFR_YEAR,AMR_FR
 106  FORMAT(6X,I4,16(F10.2))
C      print *,NYEAR,NGM,NFR_YEAR
      IF(NFR_YEAR.EQ.NYEAR-NGM)GOTO6
      JS=JS+1
      GOTO5
   6  JS=JS+1
      READ(FLN(JS),106)NFR_YR,AMR_N
      DO 7 J=1,NGAS
         DO 7 JI=1,NFR
            IF(FRN(JI).EQ.AY(J))
     *      GMR(J)=(AMC_M*AMR_FR(JI)+AMC_P*AMR_N(JI))*1.E-12
   7        CONTINUE
C      print *,TI,NFR_YEAR,NFR_YR,AMC_M,AMC_P
C      print *,AMR_FR
C      print *,AMR_N
C      pause 7
      IF(NYEAR.LT.1970.OR.NYEAR.GT.2051)GOTO8
      AA='   '
      DO WHILE(AA.NE.'Yea')
	   JS=JS+1
         READ(FLN(JS),'(2X,A3)')AA
      ENDDO
      NFR_YEAR=1964
      DO WHILE(NFR_YEAR.NE.NYEAR-NGM)
	   JS=JS+1
         READ(FLN(JS),'(I7,12F8.1)')NFR_YEAR,GHG
      ENDDO
	JS=JS+1
      READ(FLN(JS),'(I7,12F8.1)')NFR_YR,GHG_N
      DO J=1,NGAS
         IF(NBN(J).EQ.2)THEN
            IF(AY(J).EQ.'CH4')GMR(J)=(AMC_M*GHG(1)+AMC_P*GHG_N(1))*1.E-9
            IF(AY(J).EQ.'N2O')GMR(J)=(AMC_M*GHG(5)+AMC_P*GHG_N(5))*1.E-9
            IF(AY(J).EQ.'CO2')THEN
               GMR(J)=(AMC_M*GHG(9)+AMC_P*GHG_N(9))*1.E-6
               CO2PPM=GMR(J)*1.E6
            ENDIF
         ENDIF
      ENDDO
C
C     FREONS AND HALONS FOR WMO2006
C
  9   IF(NYEAR.LT.1959.OR.NYEAR.GT.2100)GOTO8
C      print *,' 9'
      AA='   '
      DO WHILE(AA.NE.'WMO')
         JS=JS+1
         READ(FLN(JS),'(1X,A3)')AA
      ENDDO
      JS=JS+1
      READ(FLN(JS),'(7X,14A8)')AMFG
      AMTI=TI/365.
      YEARD=REAL(NYEAR)+AMTI
      YEARFH=1959.00
      DO WHILE(YEARD.GT.YEARFH)
         YEARFH_O=YEARFH
         DO J=1,NFH
            GFH_O(J)=GFH(J)
         ENDDO
         JS=JS+1
         READ(FLN(JS),107)YEARFH,GFH
      ENDDO
      AMP=(YEARD-YEARFH_O)/(YEARFH-YEARFH_O)
      AMM=1.-AMP
CSPS      if(NYEAR_B.le.1990 .or. NYEAR_B.gt.1995)goto88
      goto88
      DO J=1,NGAS
         DO JI=1,NFH
            IF(AMFG(JI).EQ.AY(J))THEN
              GMR(J)=(AMM*GFH_O(JI)+AMP*GFH(JI))*1.E-12
            ENDIF
         ENDDO
      ENDDO
C
C     GREENHOUSE GASES 2006 Assessment
C
  88  AA='   '
      DO WHILE(AA.NE.'tim')
         JS=JS+1
         READ(FLN(JS),'(3X,A3)')AA
      ENDDO
      JS=JS+1
      READ(FLN(JS),'(11X,3(A8,3X))')(AMFG(J),J=1,3)
      YEARFH=1959.00
      DO WHILE(YEARD.GT.YEARFH)
         YEARFH_O=YEARFH
         DO J=1,3
            GHG_N(J)=GHG(J)
         ENDDO
         JS=JS+1
         READ(FLN(JS),'(F8.2,3F11.2)')YEARFH,(GHG(J),J=1,3)
      ENDDO
      DO J=1,NGAS
         IF(NBN(J).EQ.2)THEN
            IF(AY(J).EQ.'CO2')GMR(J)=(AMM*GHG_N(1)+AMP*GHG(1))*1.E-6
            IF(AY(J).EQ.'CH4')GMR(J)=(AMM*GHG_N(2)+AMP*GHG(2))*1.E-9
            IF(AY(J).EQ.'N2O')GMR(J)=(AMM*GHG_N(3)+AMP*GHG(3))*1.E-9
         ENDIF
      ENDDO
C      print *,YEARD,YEARFH_O,YEARFH,AMM,AMP
C      print *,GHG_N
C      print *,GHG
      CO2PPM=AMM*GHG_N(1)+AMP*GHG(1) ! **************** FIXED FOR DYNAMICS
   8  CONTINUE   !CLOSE(NCH)
C      print *,GMR
C      print *,CO2PPM
C      pause 8
 107  FORMAT(F7.2,14F8.2)
CSPS      NYEAR_B=NYEAR_TMP ! ***************************** back to current year
      RETURN
      END

